idris-1.0: Functional Programming Language with Dependent Types

Copyright | License : BSD3
Maintainer | The Idris Community.
Safe Haskell | None
Language | Haskell98

Idris.Transforms

Description

Synopsis

- transformPats :: IState -> [Either Term (Term, Term)] -> [Either Term (Term, Term)]
- transformPatsWith :: [(Term, Term)] -> [Either Term (Term, Term)] -> [Either Term (Term, Term)]
- applyTransRulesWith :: [(Term, Term)] -> Term -> Term
- applyTransRules :: IState -> Term -> Term

# Documentation

transformPats :: IState -> [Either Term (Term, Term)] -> [Either Term (Term, Term)] #

transformPatsWith :: [(Term, Term)] -> [Either Term (Term, Term)] -> [Either Term (Term, Term)] #

applyTransRulesWith :: [(Term, Term)] -> Term -> Term #

Work on explicitly named terms, so we don't have to manipulate de Bruijn indices

applyTransRules :: IState -> Term -> Term #

Work on explicitly named terms, so we don't have to manipulate de Bruijn indices